import java.lang.reflect.Array;
import java.util.Arrays;
import java.util.Collection;

public class MyArrayList <I> {
    private I[] inputArray;

    

        private static final int INTIAL_SPACES = 10;
        private I[] array;
        private int size;

        public MyArrayList() {
            array = (I[]) new Object[INTIAL_SPACES];
            size = 0;
        }

        public MyArrayList(int size) {
            array = (I[]) new Object[size];
            size = 0;
        }

        public boolean add(I element) {
            array = checkAndIncreaseCapacity( array );
            array[size] = element;
            size++;
            return true;
        }

        private I[] checkAndIncreaseCapacity(I[] array) {
            if ( size >= array.length ) {
                array = (I[]) Array.newInstance( this.array.getClass().getComponentType(), ( array.length * 3 ) / 2 + 1 );
            }
            return array;
        }


        public void add(I element, int index) {
            array = checkAndIncreaseCapacity( array );
            size++;
            I[] temp = Arrays.copyOf( array, array.length );

            for (int i = 0; i < size; i++) {
                if ( i < index ) {
                    temp[i] = array[i];
                } else if ( i == index ) {
                    temp[i] = element;
                } else {
                    temp[i] = array[i - 1];
                }
            }
            array = temp;
        }

        public I get(int index) {
            return array[index];
        }

        public I remove(int index) {
            array[index] = null;
            size--;
            I[] temp = (I[]) new Object[array.length];
            for (int i = 0; i < size; i++) {
                if ( i < index ) {
                    temp[i] = array[i];
                } else {
                    temp[i] = array[i + 1];
                }
            }
            array = temp;
            return null;
        }

        public Object[] toArray() {
            return Arrays.copyOf( this.array, size );
        }

        public <I> I[] toArray(I[] a) {
            for (int i = 0; i < size; i++) {
                a[i] = (I) this.array[i];
            }
            return a;
        }

        public void clear() {
            array = (I[]) new Object[INTIAL_SPACES];
            size = 0;
        }

        public boolean isEmpty() {
            if ( size == 0 ) return true;
            else return false;
        }

        public boolean contains(Object element) {
            if ( indexOf( element ) >= 0 ) return true;
            else return false;
        }

        public int indexOf(Object element) {
            int index = -1;
            for (int i = 0; i < size; i++) {
                if ( array[i] == element ) {
                    index = i;
                    break;
                }
            }
            return index;
        }

        public void addAll(Collection<? extends I> c) {
            Object[] toAdd = c.toArray();

            for (int i = 0; i < c.size(); i++) {
                add( (I) toAdd[i] );
            }
        }

    }
}
